#ifndef _KGR_PATCH_BSC1190118_H
#define _KGR_PATCH_BSC1190118_H

#if IS_ENABLED(CONFIG_VIRTIO_CONSOLE)

int kgr_patch_bsc1190118_init(void);
void kgr_patch_bsc1190118_cleanup(void);


struct port;
struct work_struct;
struct virtqueue;

void kgrp_discard_port_data(struct port *port);
bool kgrp_port_has_data(struct port *port);
void kgrp_control_work_handler(struct work_struct *work);
void kgrp_in_intr(struct virtqueue *vq);

#define KGR_PATCH_BSC1190118_FUNCS					\
	KGR_PATCH_OBJ(discard_port_data, kgrp_discard_port_data,	\
		      "virtio_console"),				\
	KGR_PATCH_OBJ(port_has_data, kgrp_port_has_data,		\
		      "virtio_console"),				\
	KGR_PATCH_OBJ(control_work_handler, kgrp_control_work_handler,	\
		      "virtio_console"),				\
	KGR_PATCH_OBJ(in_intr, kgrp_in_intr, "virtio_console"),	\

#else /* !IS_ENABLED(CONFIG_VIRTIO_CONSOLE) */

static inline int kgr_patch_bsc1190118_init(void) { return 0; }

static inline void kgr_patch_bsc1190118_cleanup(void) {}

#define KGR_PATCH_BSC1190118_FUNCS

#endif /* IS_ENABLED(CONFIG_VIRTIO_CONSOLE) */
#endif /* _KGR_PATCH_BSC1190118_H */
